
//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//	V.R. CONFERENCING APPLICATION                                       //
//                                                                          //
//	Written by R.M.J.Tucker                                             //
//                                                                          //
//	(C) Copyright 1996                                                  //
//                                                                          //
//	PANCAM.CPP                                                        //
//                                                                          //
//	Implementation of PANCAM class.                                   //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

#include "CAMERA\PANCAM.H"

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
// Create a blank panning camera.                                           //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////
				
PANCAM :: PANCAM ( void )

/*	PRE	:
	POST	:
*/

{

}

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
// Ready the panning camera transformation matrix.                          //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

void PANCAM :: Ready ( void )

/*	PRE	:
	POST	:
*/

{
	/*	Make a vector from current
		focus to desired focus.	*/

	VECTOR NewPos ( Initial, *Focus );

	/*	Divide it through
		by the speed.	*/

	NewPos /= ( Speed * InitialSpeed );

	/*	Increase the initial
		speed slowly.	*/

	if ( InitialSpeed > 0.1 ) {
		InitialSpeed -= 0.05;
	}

	/*	Add it to the initial
		position.	*/

	Initial += NewPos;

	/*	Now set the focus
		to this new position.	*/

	POINT *TempFocus = Focus;
	Focus = &Initial;

	/*	Ready the
		camera.	*/

	TRACKCAM :: Ready ();

	/*	Return the original
		destination focus.	*/

	Focus = TempFocus;
}


//////////////////////////////////////////////////////////////////////////////
//                                                                          //
// Set the focal point for the panning camera.                              //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

void PANCAM :: SetFocus ( POINT *f, POINT *s, REAL sp )

/*	PRE	:
	POST	:
*/

{
	Initial = *s;
	Focus = f;
	Speed = sp;
	InitialSpeed = 1.0;
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
// Set the focal point for the panning camera.                              //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

void PANCAM :: SetFocus ( POINT *f, REAL sp )

/*	PRE	:
	POST	:
*/

{
	Focus = f;
	Speed = sp;
	InitialSpeed = 1.0;
}


