
//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//	V.R. CONFERENCING APPLICATION                                       //
//                                                                          //
//	Written by R.M.J.Tucker                                             //
//                                                                          //
//	(C) Copyright 1996                                                  //
//                                                                          //
//	PANCAM.H                                                            //
//                                                                          //
//	Definition of PANCAM class.                                         //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

#if !defined ( __PANCAM__ )
	#define __PANCAM__

	#include "CAMERA\TRACKCAM.H"
	#include "MATH\PLANE.H"

	class PANCAM : public TRACKCAM {


		public :

			/*	The panning track cam
				initial view.	*/

			POINT Initial;
			
			/*	Panning track cam
				speed of rotation.	*/
				
			REAL Speed;

			/*	Initial speed of the
				panning camera.	*/

			REAL InitialSpeed;

			/*	Create a pan
				cam.	*/
				
			PANCAM ( void );

			/*	Load the track-cam matrix
				with appropriate parameters.	*/

			void Ready ( void );

			/*	Tie in the pan-cam with
				a given point in space.	*/

			void SetFocus ( POINT *f, POINT *In, REAL s );

			/*	Tie in the pan-cam, from
				it's current viewing point.	*/

			void SetFocus ( POINT *f, REAL sp );

	};
#endif


