
//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//	V.R. CONFERENCING APPLICATION                                       //
//                                                                          //
//	Written by R.M.J.Tucker                                             //
//                                                                          //
//	(C) Copyright 1996                                                  //
//                                                                          //
//	TRACKCAM.H                                                          //
//                                                                          //
//	Definition of TRACKCAM class.                                       //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

#if !defined ( __TRACKCAM__ )
	#define __TRACKCAM__

	#include "CAMERA\CAMERA.H"

	class TRACKCAM : public CAMERA {


		public :

			/*	The track cam reference
				point.	*/

			POINT	*Focus;

			/*	And the viewing
				vectors.	*/

			VECTOR Up, Right, Normal;

			/*	Create a track 
				cam.	*/
				
			TRACKCAM ( void );

			/*	Load the track-cam matrix
				with appropriate parameters.	*/

			void Ready ( void );

			/*	Tie in the track-cam with
				a given point in space.	*/

			void SetFocus ( POINT *p );
	};
#endif


