
//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//	V.R. CONFERENCING APPLICATION                                       //
//                                                                          //
//	Written by R.M.J.Tucker                                             //
//                                                                          //
//	(C) Copyright 1996                                                  //
//                                                                          //
//	COLOUR.H                                                            //
//                                                                          //
//	Implementation of COLOUR class.                                     //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////
	
#if !defined ( __COLOUR__ )
	#define __COLOUR__

	#include <dos.h>

	/*	Structure to define a gamma 
		corrected colour gradation.	*/

	class COLOUR {

		private :

			int BaseColour;
			int NumLevels;
			unsigned IntensityBits;
			int MaxRed;
			int MaxGreen;
			int MaxBlue;

		public :

			/* 	Setup a colour
				gradation.	*/

			COLOUR ();

			/*	Direct setup with
				construction.	*/

			COLOUR ( int, int, unsigned, int, int, int );

			/*	Post construction	
				setup.	*/

			void Set ( int, int, unsigned, int, int, int );

			/*	Return the colour
				parameters for this colour.	*/

			void Get ( int *, int *, unsigned * );

	};
#endif

