
//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//	V.R. CONFERENCING APPLICATION                                       //
//                                                                          //
//	Written by R.M.J.Tucker                                             //
//                                                                          //
//	(C) Copyright 1996                                                  //
//                                                                          //
//	GEOMETRY.H                                                          //
//                                                                          //
//	Definition of the GEOMETRY class.                                   //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

#if !defined ( __GEOMETRY__ )
	#define __GEOMETRY__

	#include "GEOMETRY\POLYGON.H"
	#include "MATH\POINT.H"

	class GEOMETRY {

		public :

			/*	A number of vertices,
				and polygons.	*/

			int	nVertices, nPolygons;

			/*	A pointer to an array
				of vertices.	*/

			POINT	*Vertices;

			/*	A pointer to an array
				of polygons.	*/

			POLYGON *Polygons;

			/*	Operation to setup the 
				geometry structure.	*/

			GEOMETRY ( int nv, POINT *v, int np, POLYGON *p );
	};
#endif
