
//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//	V.R. CONFERENCING APPLICATION                                       //
//                                                                          //
//	Written by R.M.J.Tucker                                             //
//                                                                          //
//	(C) Copyright 1996                                                  //
//                                                                          //
//	POLYGON.H                                                           //
//                                                                          //
//	Implementation of the POLYGON class.                                //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

#if !defined ( __POLYGON__ )
	#define __POLYGON__

	#include "MATH\POINT.H"
	#include "TEXTURE\TEXTURE.H"

	class POLYGON {

		public :

			#define MAXPOLYGONVERTEX 16

			/*	A polygon is a set of 
				indices to vertices.	*/

			int *Vertices, nVerts;

			/*	A flag to say whether
				to cull or not.	*/

			#define CULL			1
			#define NOCULL			0
			#define FLATSHADED		1
			#define TEXTURED		2
			#define TRANSPARENT		4

			int Flag;

			/*	and an inside\outside
				surface structure.	*/

			struct SIDE {

				/*	Sides have
					a base colour.	*/

				PIXEL Colour;

				/*	And a texture
					map.	*/

				TEXTUREMAP *Texture;

				/*	and some texture
					co-ordinates.	*/

				INTPOINT *TexVerts;

			} Inside, Outside;

			#define INSIDE	1
			#define OUTSIDE	2

			/*	Operation to set
				geometric properties.	*/

			void Set ( int f, int n, int *e );

			/*	Operation to set the
				colour\texture properties.	*/

			void Set ( int Side, PIXEL Colour, TEXTUREMAP *Tex, INTPOINT *TexVerts );
	};
#endif

