
//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//	V.R. CONFERENCING APPLICATION                                       //
//                                                                          //
//	Written by R.M.J.Tucker                                             //
//                                                                          //
//	(C) Copyright 1996                                                  //
//                                                                          //
//	POINT.CPP                                                           //
//                                                                          //
//	Implementation of POINT class.                                      //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////
	
#include "MATH\POINT.H"

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
// Constructor to create a point does nothing.                              //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

POINT :: POINT ( void )

/*	PRE	:	TRUE
	POST	:	TRUE
*/

{

}

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
// Constructor to initialise a point with 3 triple values.                  //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

POINT :: POINT ( REAL x, REAL y, REAL z )

/*	PRE	:	TRUE
	POST	:	This = ( x, y, z )
*/

{
	v [0] = x;
	v [1] = y;
	v [2] = z;
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
// Constructor to initialise one point with another.                        //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

POINT :: POINT ( POINT& Point )

/*	PRE	:	TRUE
	POST	:	This = Point
*/

{
	v [0] = Point.v [0];
	v [1] = Point.v [1];
	v [2] = Point.v [2];
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
// Set the values for a point.                                              //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

void POINT :: Set ( REAL x, REAL y, REAL z )

/*	PRE	:
	POST	:
*/

{
	v [0] = x;
	v [1] = y;
	v [2] = z;
}
 
//////////////////////////////////////////////////////////////////////////////
//                                                                          //
// Function to make this point equal another point.                         //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

POINT& POINT :: operator = ( POINT& Point )

/*	PRE	:	TRUE
	POST	:	This = Point
*/

{
	v [0] = Point.v [0];
	v [1] = Point.v [1];
	v [2] = Point.v [2];

	return ( *this );
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
// Function to subtract a point from this point.                            //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

POINT& POINT :: operator -= ( POINT& Point )

/*	PRE	:	TRUE
	POST	:	This = ( This - Point );
*/

{
	v [0] -= Point.v [0];
	v [1] -= Point.v [1];
	v [2] -= Point.v [2];

	return ( *this );
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
// Function to add a point to this point.                                   //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

POINT& POINT :: operator += ( POINT& Point )

/*	PRE	:	TRUE
	POST	:	This = ( This + Point )
*/

{
	v [0] += Point.v [0];
	v [1] += Point.v [1];
	v [2] += Point.v [2];

	return ( *this );
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
// Function to add a point to this point.                                   //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

POINT& POINT :: operator /= ( REAL Value )

/*	PRE	:	Value is non-zero.
	POST	:	This = This / Value
*/

{             
	v [0] /= Value;
	v [1] /= Value;
	v [2] /= Value;

	return ( *this );
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
// Scale the vector by the given amount along all axis.                     //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

POINT& POINT :: operator *= ( REAL Amount )

/*	PRE	:	TRUE
	POST	:	This = ( This * Amount )
*/

{
	v [0] *= Amount;
	v [1] *= Amount;
	v [2] *= Amount;

	return ( *this );
}

