
//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//	V.R. CONFERENCING APPLICATION                                       //
//                                                                          //
//	Written by R.M.J.Tucker                                             //
//                                                                          //
//	(C) Copyright 1996                                                  //
//                                                                          //
//	MODEFLIP.CPP                                                        //
//                                                                          //
//	Implementation of MODE class.                                       //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////
	
#include "MODE\MODE.H"

#include <dos.h>

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
// Flip the graphics pages for a planar bitmap.                             //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

void GRAPHICSMODE :: FlipPage ( void )

/*	PRE	:
	POST	:
*/

{
	/*	Wait for vertical
		retrace flag.	*/

	while ( ( inport ( STATUS_REGISTER_1 ) & VSYNC_MASK ) != 0 );

	/*	and flip the
		graphics page.	*/

	if ( Page == 0 ) {
		Offset = 0x8000;
		Page = 1;
		PAGE ( 0 );
	} else {
		Offset = 0x0;
		Page = 0;
		PAGE ( 1 );
	}

	while ( ( inport ( STATUS_REGISTER_1 ) & VSYNC_MASK ) == 0 );
}

