
//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//	V.R. CONFERENCING APPLICATION                                       //
//                                                                          //
//	Written by R.M.J.Tucker                                             //
//                                                                          //
//	(C) Copyright 1996                                                  //
//                                                                          //
//	MODESCAN.CPP                                                        //
//                                                                          //
//	Implementation of MODE class.                                       //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////
	
#include "MODE\MODE.H"

#include <dos.h>
#include <mem.h>

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
// Overscan a line onto the page.                                           //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

void GRAPHICSMODE :: OverScan ( int x1, int x2, int y, int Colour )

/*	PRE	:
	POST	:
*/

{
	int Starts [] = { 0xF, 0xE, 0xC, 0x8 }, Ends [] = { 0x1, 0x3, 0x7, 0xF }, Len, a, b, sa, sb;
	PIXEL *s;

	/*	Get the screen start
		address position.	*/

	s = GETADDRESS ( x1, y );

	/*	Find the starting
		and ending masks.	*/

	a = Starts [ ( x1 & 3 ) ];
	b = Ends [ ( x2 & 3 ) ];
	sa = ( x1 >> 2 );
	sb = ( x2 >> 2 );

	/*	If ends in same
		byte, scan and out.	*/

	if ( sa == sb ) {
		MAPMASK ( ( a & b ) );
		*s = Colour;
		return;
	}

	/*	Do the first
		end.	*/

	MAPMASK ( a );
	*s++ = Colour;

	/*	Any more to
		do?	*/

	Len = ( sb - sa );
	if ( Len > 1 ) {
		Len--;
		MAPMASK ( 0xF );
		setmem ( s, Len, Colour );
		s += Len;
	}

	/*	Now scan the
		end byte.	*/

	MAPMASK ( b );
	*s = Colour;
}

