
//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//	V.R. CONFERENCING APPLICATION                                       //
//                                                                          //
//	Written by R.M.J.Tucker                                             //
//                                                                          //
//	(C) Copyright 1996                                                  //
//                                                                          //
//	CUBE.H								    //
//                                                                          //
//	Definition of CUBE object.	                                    //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////
	
#if !defined ( __CUBE__ )
	#define __CUBE__

	#include "OBJECT\OBJECT3D.H"

	class CUBE : public OBJECT3D {

		private :

			/*	This object also has a set
				of vertices to describe it.	*/

			POINT Vertices [8];

			/*	And a set of polygons
				pointing to the vertices.	*/

			POLYGON Polygons [6];

			/*	The texture map
				for this cube.	*/

			TEXTUREMAP Texture;

		public :

			/*	Constructor set initial
				texture of the cube.	*/

			CUBE ( char *Path );

			/*	The object should put itself
				into the viewing projection ( if 
				it wants to... ).	*/

			void Show ( VIEWPROJECTION& View );
	};
#endif

