
//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//	V.R. CONFERENCING APPLICATION                                       //
//                                                                          //
//	Written by R.M.J.Tucker                                             //
//                                                                          //
//	(C) Copyright 1996                                                  //
//                                                                          //
//	WINDOW.CPP                                                          //
//                                                                          //
//	Implementation of WINDOW class.                                     //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

#include "VIEW\WINDOW.H"

WINDOW :: WINDOW ( int l, int t, int r, int b )

/*	PRE	:
	POST	:
*/

{
	Left = l;
	Top = t;
	Right = r;
	Bottom = b;
	Width = ( r - l );
	Length = ( b - t );
}

void WINDOW :: GetSize ( int *w, int *l )

/*	PRE	:
	POST	:
*/

{
	*w = Width;
	*l = Length;
}

void WINDOW :: GetArea ( int *l, int *t, int *r, int *b )

/*	PRE	:
	POST	:
*/

{
	*l = Left;
	*t = Top;
	*r = Right;
	*b = Bottom;
}

BOOL WINDOW :: ClipLine ( int *x1, int *y1, int *x2, int *y2 )

/*	PRE	:	TRUE
	POST	:
*/

{
	int a, b, c, d, code1, code2, rejected, accepted;

	a = *x1;
	b = *y1;
	c = *x2;
	d = *y2;

	do {

		code1 = ClipCode ( a, b );
		code2 = ClipCode ( c, d );

		if ( ( rejected = Reject ( code1, code2 ) ) != 0 ) {
			return ( FALSE );
		} else {
			if ( ( accepted = Accept ( code1, code2 ) ) != 0 ) {
				*x1 = a;
				*y1 = b;
				*x2 = c;
				*y2 = d;
				return ( TRUE );
			} else {
				if ( code1 == 0 ) {
					SWAP ( a, c );
					SWAP ( b, d );
					SWAP ( code1, code2 );
				}
				if ( ( code1 & 0x01 ) != 0 ) {
					a += ( c - a ) * ( float ) ( Bottom - b ) / ( d - b );
					b = Bottom;
				} else {
					if ( ( code1 & 0x02 ) != 0 ) {
						a += ( c - a ) * ( float ) ( Top - b ) / ( d - b );
						b = Top;
					} else {
						if ( ( code1 & 0x04 ) != 0 ) {
							b += ( d - b ) * ( float ) ( Right - a ) / ( c - a );
							a = Right;
						} else {
							if ( ( code1 & 0x08 ) != 0 ) {
								b += ( d - b ) * ( float ) ( Left - a ) / ( c - a );
								a = Left;
							}
						}
					}
				}
			}
		}
    } while ( 1 == 1 );
}

int WINDOW :: ClipCode ( int x, int y )

/*	PRE	:	TRUE
	POST	:
*/

{
    int code = 0;

    if ( y > Bottom )
	code |= 0x01;
    else
	if ( y < Top )
	    code |= 0x02;
    if ( x > Right )
	code |= 0x04;
    else
	if ( x < Left )
	    code |= 0x08;

    return ( code );
}

int WINDOW :: Accept ( int a, int b )

/*	PRE	:	TRUE
	POST	:
*/

{
    if ( ( a | b ) == 0 )
	return ( 1 );
    else
	return ( 0 );
}

int WINDOW :: Reject ( int a, int b )

/*	PRE	:	TRUE
	POST	:
*/

{
    if ( ( a & b ) == 0 )
	return ( 0 );
    else
	return ( 1 );
}

